PGSQL_CONTROL
-- $Id: ip_extend.m4,v 1.4 2006/03/12 04:38:54 babolo Exp $
CREATE OR REPLACE FUNCTION inet(int4) RETURNS inet
 AS '$libdir/ip_extend.so.VMAJOR'
  , 'int4_inet'
 LANGUAGE C IMMUTABLE STRICT
;
CREATE OR REPLACE FUNCTION inet(int8) RETURNS inet
 AS '$libdir/ip_extend.so.VMAJOR'
  , 'int8_inet'
 LANGUAGE C IMMUTABLE STRICT
;
CREATE OR REPLACE FUNCTION int4(inet) RETURNS int4
 AS '$libdir/ip_extend.so.VMAJOR'
  , 'inet_int4'
 LANGUAGE C IMMUTABLE STRICT
;
CREATE OR REPLACE FUNCTION int8(inet) RETURNS int8
 AS '$libdir/ip_extend.so.VMAJOR'
  , 'inet_int8'
 LANGUAGE C IMMUTABLE STRICT
;
CREATE OR REPLACE FUNCTION ip_set(inet, int) RETURNS SETOF inet
 AS '$libdir/ip_extend.so.VMAJOR'
  , 'ip_set'
 LANGUAGE C IMMUTABLE STRICT
;
CREATE OR REPLACE FUNCTION ip_set(inet) RETURNS SETOF inet
 AS 'SELECT ip_set($1, 32)
    '
 LANGUAGE SQL IMMUTABLE STRICT
;
CREATE OR REPLACE FUNCTION inet_type(inet) RETURNS int2
 AS '$libdir/ip_extend.so.VMAJOR'
  , 'inet_type'
 LANGUAGE C IMMUTABLE STRICT
;
CREATE OR REPLACE FUNCTION ip_supernet(inet) RETURNS SETOF inet
 AS '$libdir/ip_extend.so.VMAJOR'
  , 'ip_supernet'
 LANGUAGE C IMMUTABLE STRICT
;
COMMENT ON FUNCTION inet(int4)        IS ' int4  IP ';
COMMENT ON FUNCTION inet(int8)        IS ' int8  IP ';
COMMENT ON FUNCTION int4(inet)        IS ' IP   int4';
COMMENT ON FUNCTION int8(inet)        IS ' IP   int8';
COMMENT ON FUNCTION ip_set(inet, int) IS '       ';
COMMENT ON FUNCTION ip_set(inet)      IS '    ';
COMMENT ON FUNCTION inet_type(inet)   IS '   inet/cidr';
COMMENT ON FUNCTION ip_supernet(inet) IS '    ';

-- 
CREATE OR REPLACE FUNCTION ipaggr_in(cstring) RETURNS ipaggr
 AS '$libdir/ip_extend.so.VMAJOR'
  , 'ipaggr_in'
 LANGUAGE C IMMUTABLE STRICT
;
CREATE OR REPLACE FUNCTION ipaggr_out(ipaggr) RETURNS cstring
 AS '$libdir/ip_extend.so.VMAJOR'
  , 'ipaggr_out'
 LANGUAGE C IMMUTABLE STRICT
;
CREATE OR REPLACE FUNCTION add_net(ipaggr,inet) RETURNS ipaggr
 AS '$libdir/ip_extend.so.VMAJOR'
  , 'add_net'
 LANGUAGE C IMMUTABLE STRICT
;
CREATE OR REPLACE FUNCTION sub_net(ipaggr,inet) RETURNS ipaggr
 AS '$libdir/ip_extend.so.VMAJOR'
  , 'sub_net'
 LANGUAGE C IMMUTABLE STRICT
;
CREATE OR REPLACE FUNCTION add_ipaggr(ipaggr,ipaggr) RETURNS ipaggr
 AS '$libdir/ip_extend.so.VMAJOR'
  , 'add_ipaggr'
 LANGUAGE C IMMUTABLE STRICT
;
CREATE OR REPLACE FUNCTION sub_ipaggr(ipaggr,ipaggr) RETURNS ipaggr
 AS '$libdir/ip_extend.so.VMAJOR'
  , 'sub_ipaggr'
 LANGUAGE C IMMUTABLE STRICT
;
CREATE OR REPLACE FUNCTION inter_ipaggr(ipaggr,ipaggr) RETURNS ipaggr
 AS '$libdir/ip_extend.so.VMAJOR'
  , 'inter_ipaggr'
 LANGUAGE C IMMUTABLE STRICT
;
CREATE OR REPLACE FUNCTION show_net(ipaggr) RETURNS SETOF cidr
 AS '$libdir/ip_extend.so.VMAJOR'
  , 'show_net'
 LANGUAGE C IMMUTABLE STRICT
;
CREATE OR REPLACE FUNCTION check_net(ipaggr,inet) RETURNS boolean
 AS '$libdir/ip_extend.so.VMAJOR'
  , 'check_net'
 LANGUAGE C IMMUTABLE STRICT
;

CREATE TYPE ipaggr (
   internallength = VARIABLE, 
   input = ipaggr_in,
   output = ipaggr_out,
   alignment = double,
   storage = external
);

CREATE AGGREGATE sum_net (
    sfunc = add_net,
    basetype = inet,
    stype = ipaggr,
    initcond = 'f'
);

CREATE OPERATOR + (
    leftarg = ipaggr,
    rightarg = ipaggr,
    procedure = add_ipaggr,
    commutator = +
);

CREATE OPERATOR - (
    leftarg = ipaggr,
    rightarg = ipaggr,
    procedure = sub_ipaggr,
    commutator = -
);

CREATE OPERATOR * (
    leftarg = ipaggr,
    rightarg = ipaggr,
    procedure = inter_ipaggr,
    commutator = *
);

CREATE OPERATOR + (
    leftarg = ipaggr,
    rightarg = inet,
    procedure = add_net,
    commutator = +
);

CREATE OPERATOR - (
    leftarg = ipaggr,
    rightarg = inet,
    procedure = sub_net,
    commutator = -
);

COMMENT ON FUNCTION ipaggr_in(cstring)        IS '   IP ';
COMMENT ON FUNCTION ipaggr_out(ipaggr)        IS ' IP   ';
COMMENT ON FUNCTION add_net(ipaggr,inet)      IS '  IP  ';
COMMENT ON FUNCTION add_ipaggr(ipaggr,ipaggr) IS '  IP ';
COMMENT ON FUNCTION sub_net(ipaggr,inet)      IS '  IP  ';
COMMENT ON FUNCTION sub_ipaggr(ipaggr,ipaggr) IS '  IP ';
COMMENT ON FUNCTION show_net(ipaggr)          IS ' IP    ';
COMMENT ON AGGREGATE sum_net(inet)            IS '   IP ';
