undefine(substr)dnl
PGSQL_CONTROL
-- $Id: varbit.m4,v 1.1 2006/04/13 02:25:02 babolo Exp $

--    --
------------------------------
CREATE OR REPLACE FUNCTION bitex0(bit, int4) RETURNS varbit
 AS 'SELECT CASE WHEN $2 = 0 THEN ''''::varbit ELSE pg_catalog.bit($1, $2, TRUE) END'
 LANGUAGE SQL IMMUTABLE STRICT
;
COMMENT ON FUNCTION bitex0(bit, int4) IS '   ,    0';

CREATE OR REPLACE FUNCTION bitex1(bit, int4) RETURNS varbit
 AS 'SELECT CASE WHEN $2 = 0
                 THEN ''''::varbit
                 WHEN bit_length($1) > $2
                 THEN pg_catalog.bit($1, $2, TRUE)
                 WHEN bit_length($1) < $2
                 THEN bitcat($1, bitnot(pg_catalog.bit(''0''::varbit, $2 - bit_length($1), TRUE)))
                 ELSE $1
            END
    '
 LANGUAGE SQL IMMUTABLE STRICT
;
COMMENT ON FUNCTION bitex1(bit, int4) IS '   ,    1';



--  varbit  bool  AND  OR --
---------------------------------------
CREATE OR REPLACE FUNCTION boolor(varbit) RETURNS bool
 AS 'SELECT $1 <> bitex0(''''::varbit, bit_length($1))'
 LANGUAGE SQL IMMUTABLE STRICT
;
COMMENT ON FUNCTION boolor(varbit)       IS 'OR    ';

CREATE OR REPLACE FUNCTION booland(varbit) RETURNS bool
 AS 'SELECT $1 = ~bitex0(''''::varbit, bit_length($1))'
 LANGUAGE SQL IMMUTABLE STRICT
;
COMMENT ON FUNCTION booland(varbit)      IS 'AND    ';



--    , ,            --
--    ,    --
------------------------------------------------------------------------
CREATE OR REPLACE FUNCTION varbiteq(bit, bit) RETURNS bool
 AS 'SELECT bitex0($1, l) = bitex0($2, l)
      FROM (SELECT CASE WHEN l1 > l2 THEN l1 ELSE l2 END AS l
             FROM (SELECT bit_length($1) AS l1, bit_length($2) AS l2)i
           )d
    '
 LANGUAGE SQL IMMUTABLE STRICT
;
COMMENT ON FUNCTION varbiteq(bit, bit)   IS '    ';

CREATE OR REPLACE FUNCTION varbitand(bit, bit) RETURNS varbit
 AS 'SELECT bitand(bitex0($1, l), bitex0($2, l))
      FROM (SELECT CASE WHEN l1 > l2 THEN l2 ELSE l1 END AS l
             FROM (SELECT bit_length($1) AS l1, bit_length($2) AS l2)i
           )d
    '
 LANGUAGE SQL IMMUTABLE STRICT
;
COMMENT ON FUNCTION varbitand(bit, bit)  IS 'AND      ';

CREATE OR REPLACE FUNCTION varbitor(bit, bit) RETURNS varbit
 AS 'SELECT bitor(bitex0($1, l), bitex0($2, l))
      FROM (SELECT CASE WHEN l1 > l2 THEN l1 ELSE l2 END AS l
             FROM (SELECT bit_length($1) AS l1, bit_length($2) AS l2)i
           )d
    '
 LANGUAGE SQL IMMUTABLE STRICT
;
COMMENT ON FUNCTION varbitor(bit, bit)   IS 'OR      ';

CREATE OR REPLACE FUNCTION varbitxor(bit, bit) RETURNS varbit
 AS 'SELECT bitxor(bitex0($1, l), bitex0($2, l))
      FROM (SELECT CASE WHEN l1 > l2 THEN l1 ELSE l2 END AS l
             FROM (SELECT bit_length($1) AS l1, bit_length($2) AS l2)i
           )d
    '
 LANGUAGE SQL IMMUTABLE STRICT
;
COMMENT ON FUNCTION varbitxor(bit, bit)  IS 'XOR      ';

CREATE OR REPLACE FUNCTION varbitrst(bit, bit) RETURNS varbit
 AS 'SELECT bitand($1, ~bitex0($2, bit_length($1)))'
 LANGUAGE SQL IMMUTABLE STRICT
;
COMMENT ON FUNCTION varbitrst(bit, bit)  IS '$1 AND ~$2,       ';

CREATE OPERATOR ==
     ( LEFTARG = bit
     , RIGHTARG = bit
     , PROCEDURE = varbiteq
     , COMMUTATOR = ==
     )
;
COMMENT ON OPERATOR == (bit, bit)        IS '    ';

CREATE OPERATOR /|
     ( LEFTARG = bit
     , RIGHTARG = bit
     , PROCEDURE = varbitand
     , COMMUTATOR = /|
     )
;
COMMENT ON OPERATOR /| (bit, bit)        IS 'AND      ';

CREATE OPERATOR |/
     ( LEFTARG = bit
     , RIGHTARG = bit
     , PROCEDURE = varbitor
     , COMMUTATOR = |/
     )
;
COMMENT ON OPERATOR |/ (bit, bit)        IS 'OR      ';

CREATE OPERATOR ^
     ( LEFTARG = bit
     , RIGHTARG = bit
     , PROCEDURE = varbitxor
     , COMMUTATOR = ^
     )
;
COMMENT ON OPERATOR ^ (bit, bit)         IS 'XOR      ';

CREATE OPERATOR !
     ( LEFTARG = bit
     , RIGHTARG = bit
     , PROCEDURE = varbitrst
     )
;
COMMENT ON OPERATOR ! (bit, bit)         IS '$1 AND ~$2,       ';



--       --
------------------------------------------
CREATE FUNCTION varbit2numstr(varbit, text) RETURNS text
 AS 'DECLARE
        str  text;
        i    RECORD;
     BEGIN
        FOR i IN SELECT bit2num($1)
        LOOP
           IF str IS NULL
           THEN str := i.bit2num;
           ELSE str := str || $2 || i.bit2num;
           END IF;
        END LOOP;
        RETURN str;
     END;
    '
 LANGUAGE 'plpgsql' IMMUTABLE STRICT
;
COMMENT ON FUNCTION varbit2numstr(varbit, text)
 IS '   ,    .    $2'
;
CREATE OR REPLACE FUNCTION varbit2numstr(varbit, text, text) RETURNS text
 AS 'DECLARE
        num      int;
        num_prev int;
        fl       int;
        str      text;
        i        RECORD;
     BEGIN
        num_prev := 0;
        fl := 0;
        FOR i IN SELECT bit2num($1)
        LOOP
           num := i.bit2num;
           IF str IS NULL
           THEN str := num;
           ELSIF num = num_prev + 1 AND fl = 0
           THEN
              str := str || $3;
              fl := 1;
           ELSIF num <> num_prev + 1 AND fl = 1
           THEN
              str := str || num_prev || $2 || num;
              fl := 0;
           ELSIF fl = 0
           THEN str := str || $2 || num;
           END IF;
           num_prev := num;
        END LOOP;
        IF fl = 0
        THEN RETURN str;
        ELSE RETURN str || num;
        END IF;
     END;
    '
 LANGUAGE 'plpgsql' IMMUTABLE STRICT
;
COMMENT ON FUNCTION varbit2numstr(varbit, text, text)
 IS '   ,    .    $2,    $3'
;



-- / varbit --
-----------------------
CREATE OR REPLACE FUNCTION varbit(text) RETURNS varbit
 AS 'DECLARE
        i int;
        r varbit;
        c char;
     BEGIN
        r := ''''::varbit;
        FOR i IN 1..length($1) LOOP
           c := substr($1, i, 1);
           IF c = ''1''
           THEN r := varbitor(r, bitex0(''1''::varbit, i) >> (i - 1));
           ELSIF c <> ''0''
           THEN RAISE EXCEPTION ''"%" is not a valid binary digit'', c;
           END IF;
        END LOOP;
        RETURN r;
     END;
    '
 LANGUAGE 'plpgsql' IMMUTABLE STRICT
;
COMMENT ON FUNCTION varbit(text) IS '   varbit';

CREATE OR REPLACE FUNCTION text(varbit) RETURNS text 
 AS 'DECLARE
        i int;
        t text;
     BEGIN
        t := ''''::text;
        FOR i IN 1..bit_length($1) LOOP
           IF boolor(varbitand($1, (bitex0(''1''::varbit, i) >> (i - 1))))
           THEN t := t || ''1'';
           ELSE t := t || ''0'';
           END IF;
        END LOOP;
        RETURN t;
     END;
    '
 LANGUAGE 'plpgsql' IMMUTABLE STRICT
;
COMMENT ON FUNCTION varbit(text) IS '   varbit';



-- ,   --
--------------------------
CREATE OPERATOR /|/
     ( LEFTARG = bit
     , RIGHTARG = bit
     , PROCEDURE = varbitxor
     , COMMUTATOR = /|/
     )
;
CREATE OR REPLACE FUNCTION bitreset(varbit, int4) RETURNS varbit
 AS 'SELECT varbitrst($1, num2bit($2))'
 LANGUAGE SQL IMMUTABLE STRICT
;
